variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  image:
    name: sonarsource/sonar-scanner-cli:5.0.1
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - 'echo "sonar-values:"'
    - 'echo "  sonar.token: ${SONAR_TOKEN}"'
    - 'echo "  sonar.host.url: ${SONAR_HOST_URL}"'
    - 'echo "  sonar.pullrequest.key: ${CI_MERGE_REQUEST_IID}"'
    - 'echo "  sonar.pullrequest.base: ${CI_MERGE_REQUEST_TARGET_BRANCH_NAME}"'
    - 'echo "  sonar.pullrequest.branch: ${CI_COMMIT_REF_NAME}"'
    - sonar-scanner -X
  only:
    - main
    - branch-**

sonarcloud-merge-check:
  image:
    name: sonarsource/sonar-scanner-cli:5.0.1
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - 'echo "sonar-values:"'
    - 'echo "  sonar.token: ${SONAR_TOKEN}"'
    - 'echo "  sonar.host.url: ${SONAR_HOST_URL}"'
    - 'echo "  sonar.pullrequest.key: ${CI_MERGE_REQUEST_IID}"'
    - 'echo "  sonar.pullrequest.base: ${CI_MERGE_REQUEST_TARGET_BRANCH_NAME}"'
    - 'echo "  sonar.pullrequest.branch: ${CI_COMMIT_REF_NAME}"'
    - sonar-scanner -X -Dsonar.pullrequest.key=${CI_MERGE_REQUEST_IID} -Dsonar.pullrequest.base=${CI_MERGE_REQUEST_TARGET_BRANCH_NAME} -Dsonar.pullrequest.branch=${CI_COMMIT_REF_NAME}
  only:
    - merge_requests


# sonar-check:
#   stage: sonar-check
#   image:
#     name: sonarsource/sonar-scanner-cli:5.0.1
#     entrypoint: [""]
#   tags: !reference [.global_tags, tags]
#   retry: !reference [.global_retry, retry]
#   cache:
#     key: "${CI_JOB_NAME}"
#     paths:
#       - .sonar/cache
#   script:
#     - 'echo "sonar-values:"'
#     - 'echo "  sonar.token: ${SONAR_TOKEN}"'
#     - 'echo "  sonar.host.url: ${SONAR_HOST_URL}"'
#     - sonar-scanner -X -Dsonar.pullrequest.key=${CI_MERGE_REQUEST_IID} -Dsonar.pullrequest.base=${CI_MERGE_REQUEST_TARGET_BRANCH_NAME} -Dsonar.pullrequest.branch=${CI_COMMIT_REF_NAME}
#   needs:
#     - job: sonar-prepare
#   rules:
#     - if: $Flow=="sonar_check"
#       when: always
#       allow_failure: true
#     - if: $Flow=="deploy_cluster"
#       when: always
#       allow_failure: true
#     - if: $Flow=="skip_gitlab_env"
#       when: always
#       allow_failure: true
#     - if: $Flow=="MR" && $CI_MERGE_REQUEST_TARGET_BRANCH_PROTECTED != "true"
#       when: always
#       allow_failure: true
#     - if: $Flow=="MR" && $CI_MERGE_REQUEST_TARGET_BRANCH_PROTECTED == "true"
#       when: always
#       allow_failure: false
